# frozen_string_literal: true
require "facebook/messenger"
require "redis"
require_relative "lib/sample"

include Facebook::Messenger

Facebook::Messenger.configure do |config|
  config.access_token = ENV["FACEBOOK_ACCESS_TOKEN"]
  config.app_secret   = ENV["FACEBOOK_APP_SECRET"]
  config.verify_token = ENV["FACEBOOK_VERIFY_TOKEN"]
end

Facebook::Messenger::Thread.set(
  setting_type: "greeting",
  greeting: { text: Sample::Chatbot.new.greet }
)

Facebook::Messenger::Subscriptions.subscribe

redis = Redis.new

Bot.on :message do |message|
  request = message.text

  response = nil
  Sample::Chatbot.persisted(redis, message.sender["id"]) do |chatbot|
    response = chatbot.respond_to_message(request)
  end

  Bot.deliver(
    recipient: message.sender,
    message: { text: response }
  )
end
